﻿-- ** Cattle Breeds for Farming Simulator 19 ** --
-- Base mod: Meliandah's "Animal Species"
-- Editor: Giuh
-- Version : 1.1
-- Changelog: Tweaked buy/sell and transport prices. Fixed Brahman birthrate. (v1.1)
 
cattlebreeds = {}

function cattlebreeds:debug(message)
  print(('### Cattle Breeds : %s'):format(message));
end;

function cattlebreeds:rpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return cattlebreeds:ternary(str ~= nil, string.rep(char, len - #tostring(str)) .. tostring(str), string.rep(char, len));
end
function cattlebreeds:lpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return cattlebreeds:ternary(str ~= nil, tostring(str) .. string.rep(char, len - #tostring(str)), string.rep(char, len));
end
function cattlebreeds:ternary(cond, T, F)
    if cond then return T else return F end
end

function cattlebreeds:updateAnimalTypes()

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do
      --DebugUtil.printTableRecursively(v, ".", 0, 10);
	  for sk,sv in pairs(v.subTypes) do

      -- PARAMETERS ------------------------------------------------------------
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 3.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.8;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.buyPrice = 2700.0;
                sv.storeInfo.sellPrice = 1400.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Red Poll'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.8;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BROWN_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 7.8;
                sv.output.manurePerDay = sv.output.manurePerDay * 3.3;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 3.3;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.4;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.buyPrice = 2500.0;
                sv.storeInfo.sellPrice = 850.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Ayrshire'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.0;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BLACK' then
                sv.output.milkPerDay = sv.output.milkPerDay * 7.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 2.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 1.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.8;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.buyPrice = 3800.0;
                sv.storeInfo.sellPrice = 2100.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Angus'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.8;          
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BLACK_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 10.5;
                sv.output.manurePerDay = sv.output.manurePerDay * 5.1;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 4.1;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.7;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.0;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.buyPrice = 3950.0;
                sv.storeInfo.sellPrice = 975.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Holstein'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.0;       
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 1.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.8;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.buyPrice = 2800.0;
                sv.storeInfo.sellPrice = 1500.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Brahman (brown)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.8;    
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_WHITE' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 1.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.8;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;           
                sv.storeInfo.buyPrice = 2800.0;
                sv.storeInfo.sellPrice = 1500.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Brahman (white)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.8;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_LIGHT_BROWN' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 1.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.8;
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.buyPrice = 2800.0;
                sv.storeInfo.sellPrice = 1500.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.storeInfo.shopItemName = ('Brahman (light brown)'):format(sv.storeInfo.shopItemName);
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.8;
      end;
      
      if sv.fillTypeDesc.name == 'COW_TYPE_BRAHMAN_GREY' then
                sv.output.milkPerDay = sv.output.milkPerDay * 5.0;
                sv.output.manurePerDay = sv.output.manurePerDay * 1.5;
                sv.output.liquidManurePerDay = sv.output.liquidManurePerDay * 2.5;
                sv.input.foodPerDay = sv.input.foodPerDay * 1.5;
                sv.input.waterPerDay = sv.input.waterPerDay * 1.8; 
                sv.input.strawPerDay = sv.input.strawPerDay * 1.0;
                sv.storeInfo.shopItemName = ('Brahman (grey)'):format(sv.storeInfo.shopItemName);             
                sv.storeInfo.buyPrice = 2800.0;
                sv.storeInfo.sellPrice = 1500.0;
                sv.storeInfo.transportPrice = 900.0;
                sv.breeding.birthRatePerDay = sv.breeding.birthRatePerDay * 1.8;
      end;
    end;
  end;
end;

function cattlebreeds:loadMap(name)    
    cattlebreeds:updateAnimalTypes();
end;

function cattlebreeds:keyEvent(unicode, sym, modifier, isDown)
end;

function cattlebreeds:update(dt)
end;

function cattlebreeds:draw()
end;

function cattlebreeds:deleteMap()
end;

function cattlebreeds:mouseEvent(posX, posY, isDown, isUp, button)
end;

addModEventListener(cattlebreeds);